# ifndef __BackupAction_H_
# define __BackupAction_H_

# include "UndoRedo.h"

class CBackupAction : public CEditAction {
  public:
	CBackupAction (CEditAction * _pAction) : m_pAction (_pAction) {}
	~CBackupAction ();

	virtual void GetName (string_t & _str) const;
	virtual cu_t CanUndo () const {return cuYes;}
	virtual bool Do ();
	virtual void Undo ();
	virtual void Redo ();

  private:
	CEditAction * m_pAction;
	map_t         m_map;
	find_info_m_t m_Selection;
	bool          m_bWasModified;
};

////////////////////////////////////////////////////////

struct CInvokeOnBackupMap {
	typedef void (* pvfv_t) ();
	const pvfv_t m_pf;

	CInvokeOnBackupMap (pvfv_t _pf);

	// The linked list.
	CInvokeOnBackupMap * m_pNext;
	static CInvokeOnBackupMap * s_pFirst;
};

# define INVOKE_ON_BACKUP_MAP(_pf) static CInvokeOnBackupMap _InvokeOnBackupMap_##_pf (_pf);

# endif // __BackupAction_H_