# ifndef __COMDocument_H_
# define __COMDocument_H_

# include "COMBase.h"
# include "GPSMapEditItf.h"

struct map_t;

class CComDocument :
	public CComDualInterface<IDocument, & LIBID_GPSMapEdit>
{
  public:
	CComDocument (map_t & _map) : m_map (_map) {}

	// IDocument.
	STDMETHOD (get_Name) (BSTR * _ret);
	STDMETHOD (put_Name) (BSTR _bstrVal);
	STDMETHOD (get_ID)   (BSTR * _ret);
	STDMETHOD (put_ID)   (BSTR _bstrVal);
	STDMETHOD (get_Copyright) (BSTR * _ret);
	STDMETHOD (put_Copyright) (BSTR _bstrVal);

	STDMETHOD (get_Objects) (long * _ret);
	STDMETHOD (get_FirstObject) (IMapObject ** _ret);
	STDMETHOD (CreateObject) (ObjectKind _Kind, IMapObject ** _ret);

	STDMETHOD (get_ZoomLevels) (long * _ret);
	STDMETHOD (GetZoomLevel)    (long _lLevel, long * _plBits, long * _plBitsRangeTo, long * _plMSZoom);
	STDMETHOD (SetZoomLevel)    (long _lLevel, long _lBits, long _lBitsRangeTo, long _lMSZoom);
	STDMETHOD (InsertZoomLevel) (long _lLevel, long _lBits, long _lBitsRangeTo, long _lMSZoom);
	STDMETHOD (DeleteZoomLevel) (long _lLevel);

	STDMETHOD (get_MinLatitude)  (double * _ret);
	STDMETHOD (get_MaxLatitude)  (double * _ret);
	STDMETHOD (get_MinLongitude) (double * _ret);
	STDMETHOD (get_MaxLongitude) (double * _ret);
	
	STDMETHOD (get_FormatID) (BSTR * _ret);

	STDMETHOD (get_Invisible) (VARIANT_BOOL * _ret);
	STDMETHOD (put_Invisible) (VARIANT_BOOL _Val);
  private:
	map_t & m_map;
};

# endif // __COMDocument_H_