# ifndef __COMElement_H_
# define __COMElement_H_

# include "COMBase.h"
# include "GPSMapEditItf.h"

struct rgn_t;

class CComElement :
	public CComDualInterface<IElement, & LIBID_GPSMapEdit>
{
  public:
	CComElement (rgn_t * _pRgn, size_t _cElement) : m_pRgn (_pRgn), m_cElement (_cElement) {}

	// IElement.
	STDMETHOD (get_Points) (VARIANT * _ret);
	STDMETHOD (put_Points) (const VARIANT * _pPoints);

	STDMETHOD (get_IsHole) (VARIANT_BOOL * _ret);
	STDMETHOD (put_IsHole) (VARIANT_BOOL _lVal);

	STDMETHOD (get_Level) (long * _ret);
	STDMETHOD (put_Level) (long _lVal);

	STDMETHOD (get_NextElement) (IElement ** _ppRet);

	STDMETHOD (Delete) ();
	STDMETHOD (get_IsDeleted) (VARIANT_BOOL * _ret);

	STDMETHOD (AddToSelection) ();
	STDMETHOD (get_IsSelected) (VARIANT_BOOL * _ret);

  private:
	rgn_t * const m_pRgn;
	const size_t m_cElement;
};

# endif // __COMElement_H_