# ifndef __COMMapObject_H_
# define __COMMapObject_H_

# include "COMBase.h"
# include "GPSMapEditItf.h"

struct rgn_t;

class CComMapObject :
	public CComDualInterface<IMapObject, & LIBID_GPSMapEdit>
{
  public:
	CComMapObject (rgn_t * _pRgn) : m_pRgn (_pRgn) {}

	// IMapObject.
	STDMETHOD (get_Label) (BSTR * _ret);
	STDMETHOD (put_Label) (BSTR _bstrVal);
	STDMETHOD (get_Kind) (ObjectKind * _ret);
	STDMETHOD (get_Type) (long * _ret);
	STDMETHOD (put_Type) (long _lVal);
	STDMETHOD (get_EndLevel) (long * _ret);
	STDMETHOD (put_EndLevel) (long _lVal);
	STDMETHOD (get_FileRef) (BSTR * _ret);

	STDMETHOD (get_Elements) (long * _ret);
	STDMETHOD (GetElement) (long _lIndex, IElement ** _ppRet);
	STDMETHOD (AddElement) (IElement ** _ppRet);

	STDMETHOD (get_IsMapObject) (VARIANT_BOOL * _ret);
	STDMETHOD (get_IsAttached)  (VARIANT_BOOL * _ret);
	STDMETHOD (get_IsBookmark)  (VARIANT_BOOL * _ret);
	STDMETHOD (get_IsNote)      (VARIANT_BOOL * _ret);
	STDMETHOD (get_IsWTR)       (VARIANT_BOOL * _ret);
	STDMETHOD (get_IsTrack)     (VARIANT_BOOL * _ret);
	STDMETHOD (get_IsWaypoint)  (VARIANT_BOOL * _ret);
	STDMETHOD (get_IsRoute)     (VARIANT_BOOL * _ret);

	STDMETHOD (get_Country)     (BSTR * _ret);
	STDMETHOD (put_Country)     (BSTR _bstrVal);
	STDMETHOD (get_Region)      (BSTR * _ret);
	STDMETHOD (put_Region)      (BSTR _bstrVal);
	STDMETHOD (get_City)        (BSTR * _ret);
	STDMETHOD (put_City)        (BSTR _bstrVal);
	STDMETHOD (get_Street)      (BSTR * _ret);
	STDMETHOD (put_Street)      (BSTR _bstrVal);
	STDMETHOD (get_Number)      (BSTR * _ret);
	STDMETHOD (put_Number)      (BSTR _bstrVal);
	STDMETHOD (get_Phone)       (BSTR * _ret);
	STDMETHOD (put_Phone)       (BSTR _bstrVal);
	STDMETHOD (get_Fax)         (BSTR * _ret);
	STDMETHOD (put_Fax)         (BSTR _bstrVal);
	STDMETHOD (get_Email)       (BSTR * _ret);
	STDMETHOD (put_Email)       (BSTR _bstrVal);
	STDMETHOD (get_WebPage)     (BSTR * _ret);
	STDMETHOD (put_WebPage)     (BSTR _bstrVal);
	STDMETHOD (get_Description) (BSTR * _ret);
	STDMETHOD (put_Description) (BSTR _bstrVal);
	STDMETHOD (get_Comment)     (BSTR * _ret);
	STDMETHOD (put_Comment)     (BSTR _bstrVal);

	STDMETHOD (get_NextObject) (IMapObject ** _ppRet);

	STDMETHOD (Delete) ();
	STDMETHOD (get_IsDeleted) (VARIANT_BOOL * _ret);

	STDMETHOD (AddToSelection) ();
	STDMETHOD (get_IsSelected) (VARIANT_BOOL * _ret);
	STDMETHOD (get_HasSelectedElements) (VARIANT_BOOL * _ret);

  private:
	rgn_t * const m_pRgn;
};

# endif // __COMMapObject_H_