# ifndef __COMPath_H_
# define __COMPath_H_

# include "COMBase.h"
# include "GPSMapEditItf.h"

struct CPath_t;

class CComPath : public CComDualInterface<IPath, & LIBID_GPSMapEdit> {
  public:
	CComPath (CPath_t & _path) : m_path (_path) {}

	STDMETHOD (Delete) ();

	STDMETHOD (get_Color) (long * _ret);
	STDMETHOD (put_Color) (long _lVal);

	STDMETHOD (get_HighlightedColor) (long * _ret);
	STDMETHOD (put_HighlightedColor) (long _lVal);

	STDMETHOD (get_Width) (long * _ret);
	STDMETHOD (put_Width) (long _lVal);

	STDMETHOD (get_HighlightedSegmentFrom) (long * _ret);
	STDMETHOD (get_HighlightedSegmentTo)   (long * _ret);
	STDMETHOD (SetHighlightedSegment) (long _lFrom, long _lTo);

	STDMETHOD (get_Points) (long * _ret);
	STDMETHOD (AppendPoint) (double _Latitude, double _Longitude);
	STDMETHOD (AppendPoints) (const VARIANT * _pPoints);
	STDMETHOD (DeleteAllPoints) ();

	STDMETHOD (get_Hidden) (VARIANT_BOOL * _ret);
	STDMETHOD (put_Hidden) (VARIANT_BOOL _bVal);

	STDMETHOD (get_Tag) (VARIANT * _ret);
	STDMETHOD (put_Tag) (const VARIANT * _pVal);

	STDMETHOD (SetInfotipsForPoints) (BSTR _bstrInfotips, BSTR _bstrDelimiter);
	STDMETHOD (AppendInfotipForPoints) (BSTR _bstrInfotip);

	STDMETHOD (get_Infotip) (BSTR * _ret);
	STDMETHOD (put_Infotip) (BSTR _bstrVal);

	STDMETHOD (get_ShowDirection) (VARIANT_BOOL * _ret);
	STDMETHOD (put_ShowDirection) (VARIANT_BOOL _bVal);

	STDMETHOD (get_ShowVertices) (VARIANT_BOOL * _ret);
	STDMETHOD (put_ShowVertices) (VARIANT_BOOL _bVal);
	STDMETHOD (get_VertexSize) (long * _ret);
	STDMETHOD (put_VertexSize) (long _lVal);

	STDMETHOD (get_FillArea) (VARIANT_BOOL * _ret);
	STDMETHOD (put_FillArea) (VARIANT_BOOL _bVal);
	STDMETHOD (get_AreaColor) (long * _ret);
	STDMETHOD (put_AreaColor) (long _lVal);
	STDMETHOD (get_TransparentArea) (VARIANT_BOOL * _ret);
	STDMETHOD (put_TransparentArea) (VARIANT_BOOL _bVal);

	STDMETHOD (get_Label) (BSTR * _ret);
	STDMETHOD (put_Label) (BSTR _bstrVal);
	STDMETHOD (get_LabelColor) (long * _ret);
	STDMETHOD (put_LabelColor) (long _lVal);

  private:
	CPath_t & m_path;
};

# endif // __COMPath_H_