# ifndef __COMStatus_H_
# define __COMStatus_H_

# include "COMBase.h"
# include "GPSMapEditItf.h"

class CComStatusBar :
	public CComDualInterface<IStatusBar, & LIBID_GPSMapEdit>,
	public CComConnectionPoint<IStatusEventsSink>
{
  public:
	typedef CComDualInterface<IStatusBar, & LIBID_GPSMapEdit> Base_t;
	typedef CComConnectionPoint<IStatusEventsSink> Base2_t;

	CComStatusBar () : m_dwAdviseCookie (0) {}

	virtual void _Delete () {}

	// IUnknown.
	STDMETHOD_ (ULONG, AddRef)  () {return Base_t::AddRef ();}
	STDMETHOD_ (ULONG, Release) () {return Base_t::Release ();}
	STDMETHOD (QueryInterface) (REFIID _iid, void ** _ppvObject) {
		const HRESULT hr = Base_t::QueryInterface (_iid, _ppvObject);
		if (FAILED (hr))
			return Base2_t::QueryInterface (_iid, _ppvObject);
		return hr;
	}

	////////////////////////////////////////////////

	// IStatusBar
	STDMETHOD (_Advise) (IStatusEventsSink * _pSink);
	DWORD m_dwAdviseCookie;
};

extern CComStatusBar g_ComStatusBar;

# endif // __COMStatus_H_