//
// GPSMapEdit
// (c) Konstantin Galichsky (kg@geopainting.com), 2009
//
// COM object model: the host object for view plug'in.
//

# include "StdAfx.h"
# include "COMViewPluginHost.h"

CComViewPluginHost g_ComViewPluginHost;

///////////////////////////////////////////////////////////////

# include "Position.h"
# include "PtAlgo.h"

STDMETHODIMP CComViewPluginHost::ConvertPosition2View (double _Latitude, double _Longitude, long * _pX, long * _pY) {
	* _pX = XToScreen (_Longitude);
	* _pY = YToScreen (_Latitude);

	return S_OK;
}

STDMETHODIMP CComViewPluginHost::ConvertView2Position (long _x, long _y, double * _pLatitude, double * _pLongitude) {
	point_t point;
	ScreenToPt (_x, _y, point);

	* _pLongitude = point.x;
	* _pLatitude  = point.y;

	return S_OK;
}

///////////////////////////////////////////////////////////////

# include "Scale.h"

STDMETHODIMP CComViewPluginHost::get_Scale (double * _ret) {
	* _ret = g_fScale*c_pixels_per_cm*100;
	return S_OK;

}

///////////////////////////////////////////////////////////////

# include "MapView.h"

STDMETHODIMP CComViewPluginHost::Refresh () {
	::Refresh ();
	return S_OK;
}

STDMETHODIMP CComViewPluginHost::DelayedRefresh (long _lTimeout) {
	::DelayedRefresh (_lTimeout);
	return S_OK;
}

STDMETHODIMP CComViewPluginHost::Redraw () {
	::Redraw ();
	return S_OK;
}

///////////////////////////////////////////////////////////////

# include "ViewPlugins.h"

STDMETHODIMP CComViewPluginHost::GetSwitch (IViewPlugin * _pPlugin, long _lSwitchIdx, VARIANT_BOOL * _ret) {
	* _ret = ViewPlugins_GetSwitch (_pPlugin, _lSwitchIdx) ? VARIANT_TRUE : VARIANT_FALSE;
	return S_OK;
}

STDMETHODIMP CComViewPluginHost::SetSwitch (IViewPlugin * _pPlugin, long _lSwitchIdx, VARIANT_BOOL _vbCheck) {
	ViewPlugins_SetSwitch (_pPlugin, _lSwitchIdx, _vbCheck != VARIANT_FALSE);
	return S_OK;
}

STDMETHODIMP CComViewPluginHost::EnableSwitch (IViewPlugin * _pPlugin, long _lSwitchIdx, VARIANT_BOOL _vbEnable) {
	ViewPlugins_EnableSwitch (_pPlugin, _lSwitchIdx, _vbEnable != VARIANT_FALSE);
	return S_OK;
}

///////////////////////////////////////////////////////////////

# include "Log.h"

STDMETHODIMP CComViewPluginHost::ReportMessage (BSTR _bstrMessage, VARIANT_BOOL _vbWarning) {
	USES_CONVERSION;
	if (_vbWarning == VARIANT_FALSE)
		ReportText (OLE2A (_bstrMessage));
	else
		ReportWarning (OLE2A (_bstrMessage));
	return S_OK;
}

STDMETHODIMP CComViewPluginHost::ClosePlugins () {
	return E_NOTIMPL;
}

STDMETHODIMP CComViewPluginHost::RestartPlugins () {
	return E_NOTIMPL;
}