# ifndef __COMViewPluginHost_H_
# define __COMViewPluginHost_H_

# include "COMBase.h"
# include "GPSMapEditItf.h"

class CComViewPluginHost : public CComVtblInterface<IViewPluginHost> {
  public:
	STDMETHOD_ (ULONG, AddRef)  () {return 0;}
	STDMETHOD_ (ULONG, Release) () {return 0;}
	//virtual void _Delete () {}

	// IViewPluginHost.
	STDMETHOD (ConvertPosition2View) (double _Latitude, double _Longitude, long * _pX, long * _pY);
	STDMETHOD (ConvertView2Position) (long _x, long _y, double * _pLatitude, double * _pLongitude);
	STDMETHOD (get_Scale) (double * _ret);

	STDMETHOD (Refresh) ();
	STDMETHOD (DelayedRefresh) (long _lTimeout);
	STDMETHOD (Redraw) ();

	STDMETHOD (GetSwitch)    (IViewPlugin * _pPlugin, long _lSwitchIdx, VARIANT_BOOL * _ret);
	STDMETHOD (SetSwitch)    (IViewPlugin * _pPlugin, long _lSwitchIdx, VARIANT_BOOL _vbCheck);
	STDMETHOD (EnableSwitch) (IViewPlugin * _pPlugin, long _lSwitchIdx, VARIANT_BOOL _vbEnable);

	STDMETHOD (ReportMessage) (BSTR _bstrMessage, VARIANT_BOOL _vbWarning);

	STDMETHOD (ClosePlugins) ();
	STDMETHOD (RestartPlugins) ();
};

extern CComViewPluginHost g_ComViewPluginHost;

# endif // __COMViewPluginHost_H_