//
// GPSMapEdit
// (c) Konstantin Galichsky (kg@geopainting.com), 2009
//
// Find road by RoadID.
//

# include "StdAfx.h"
# include "FindRoadID.h"
# include "EditNumber.h"
# include "Map.h"
# include "MapView.h"
# include "ShowRgnOnMap.h"
# include "Wrappers.h"
# include "Globals.h"

void FindRoadID () {
	size_t cRoadID = 0;
	if (! EditNumber (g_hWnd, cRoadID, "Find road by RoadID:"))
		return;

	{
		CCritSec::CLock lock (g_cs);

		const layer_t & polylines = g_map.layers [rkPolyline];
		const rgns_t & rgns = polylines.rgns;
		for (rgns_t::const_iterator iRgn = rgns.begin (); iRgn != rgns.end (); ++ iRgn) {
			const rgn_t & rgn = * iRgn;
			if (rgn.IsImmutable ())
				continue;

			if (rgn.pExtra && rgn.pExtra->dwRoadID == cRoadID) {
				ShowRgnOnMap (rgn);
				Refresh ();

				return;
			}
		}
	}

	ErrorMsgBox ("Road ID is not found.");
}