//
// GPSMapEdit
// (c) Konstantin Galichsky (kg@geopainting.com), 2009
//
// Icon wrapper.
//

# include "StdAfx.h"
# include "Icon.h"
# include "Wrappers.h"
# include "Globals.h"

# pragma pack (push, 1)

struct ICONDIRENTRY {
	BYTE  btWidth;
	BYTE  btHeight;
	BYTE  btColorCount;
	BYTE  btReserved;
	WORD  wPlanes;
	WORD  wBitCount;
	DWORD dwBytesInRes;
	DWORD dwImageOffset;
};

struct ICONDIR {
	WORD wReserved;
	WORD wType;
	WORD wCount;
	ICONDIRENTRY Entries [1];
};

# pragma pack (pop)


CIcon::CIcon (const char * _strFileName) :
	m_hicon (NULL),
	m_w (0),
	m_h (0)
{
	CFileForRead hFile (_strFileName);
	if (! hFile.IsValid ())
		return;
	const DWORD dwSize = ::GetFileSize (hFile, NULL);
	BYTE * const pData = (BYTE *) ::alloca (dwSize);
	DWORD dwRead;
	::ReadFile (hFile, pData, dwSize, & dwRead, NULL);

	const ICONDIR * const pHdr = reinterpret_cast<const ICONDIR *> (pData);
	const ICONDIRENTRY & ide = pHdr->Entries [0];

	m_hicon = ::CreateIconFromResourceEx (pData + ide.dwImageOffset, ide.dwBytesInRes, TRUE, 0x00030000, ide.btWidth, ide.btHeight, LR_DEFAULTCOLOR);
	m_w = ide.btWidth;
	m_h = ide.btHeight;

//	::ExtractIconEx (_strFileName, 0, NULL, & m_hicon, 1);
}

CIcon::~CIcon () {
	if (m_hicon)
		::DestroyIcon (m_hicon);
}

void CIcon::Draw (HDC _hdc, int _x, int _y, int _w, int _h, bool _bDrawImage, bool _bDrawMask) const {
	::DrawIconEx (_hdc, _x, _y, m_hicon, _w, _h, 0, NULL, (_bDrawImage ? DI_IMAGE : 0) + (_bDrawMask ? DI_MASK : 0));
}