//
// GPSMapEdit
// (c) Konstantin Galichsky (kg@geopainting.com), 2008
//
// Kernel drivers helpers.
//

# include "StdAfx.h"
# include "Kernel.h"

# pragma comment (lib, "setupapi.lib")

HANDLE OpenDriverWithClass (const GUID & _guidClass) {
	const CDevInfoHandle hDevInfo = ::SetupDiGetClassDevs (
		& _guidClass,
		NULL, NULL, DIGCF_PRESENT | DIGCF_INTERFACEDEVICE
	);

	SP_DEVICE_INTERFACE_DATA InterfaceData;
	InterfaceData.cbSize = sizeof (InterfaceData);
	if (
		! ::SetupDiEnumDeviceInterfaces (
			hDevInfo,
			NULL,
			& _guidClass,
			0,
			& InterfaceData
		) && ::GetLastError () == ERROR_NO_MORE_ITEMS
	)
		return NULL;

	DWORD dwDetailDataSize = 0;
	::SetupDiGetDeviceInterfaceDetail (
		hDevInfo,
		& InterfaceData,
		NULL,
		0,
		& dwDetailDataSize,
		NULL
	);

	PSP_INTERFACE_DEVICE_DETAIL_DATA pDevDetailData = (PSP_INTERFACE_DEVICE_DETAIL_DATA) alloca (dwDetailDataSize);
	pDevDetailData->cbSize = sizeof (SP_INTERFACE_DEVICE_DETAIL_DATA);

	SP_DEVINFO_DATA DevInfoData = {sizeof (SP_DEVINFO_DATA)};
	::SetupDiGetDeviceInterfaceDetail (
		hDevInfo,
		& InterfaceData,
		pDevDetailData,
		dwDetailDataSize,
		NULL,
		& DevInfoData
	);

	return ::CreateFile (
		pDevDetailData->DevicePath,
		GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	);
}
