#ifndef __apiLCM__
#define __apiLCM__



#define ROADSYMBOL_119 119
#define ROADSYMBOL_120 120
#define ROADSYMBOL_121 121
#define ROADSYMBOL_122 122
#define ROADSYMBOL_123 123
#define ROADSYMBOL_124 124

#define CITYNAME_LEVEL_141 141
#define CITYNAME_LEVEL_142 142
#define CITYNAME_LEVEL_143 143



//using namespace std;
struct structPOI
{
   long   lPOIType;
//   long   lSubType; 
   double dLatitude;
   double dLongitude;      
   long   lNumAddress;
   char*   sName;
   char*   sDescription;
   char*   sAddressPre;
   char*   sAddressPost;
   char*   sCity;
   char*   sCounty;
   char*   sState;
   char*   sCountry;
   char*   sZip;
   char*   sPhone;
};

extern "C" long SetMasterMode(unsigned long* lMode);

extern "C" long NewLCMFile(const char* sFileName);
extern "C" long BuildLCM();
extern "C" void Bounds(double* lat, double* lon);
extern "C" void GetBounds(double* lat1, double* lon1, double* lat2, double* lon2);
extern "C" void ClearLCM();

extern "C" long Lake(long* lDataSet);
extern "C" long LakePoint(long* lDataset, long* index, double* lat, double* lon);

extern "C" long Swamp(long* lDataSet);
extern "C" long SwampPoint(long* lDataset, long* index, double* lat, double* lon);

extern "C" long Ocean(long* lDataSet);
extern "C" long OceanPoint(long* lDataset, long* index, double* lat, double* lon);

extern "C" long Contour(long* lDataSet, long* lType, double* dLevel);
extern "C" long ContourPoint(long* lDataSet, long* index, double* dLat, double* dLon);
extern "C" long Elevation(long* lDataSet, long* lType, double* dLevel);
extern "C" long ElevationPoint(long* lDataSet, long* index, double* dLat, double* dLon);

extern "C" long Road(long* lDataSet, char* sRoadName, long* lLevel);
extern "C" long RoadSegment(long* lDataSet, long* lRoadNumber);
extern "C" long RoadPoint(long* lDataSet, long* lRoadNumber, long* lRoadSegmentNumber, double* lat, double* lon);
extern "C" long RoadSymbol(long* lDataSet, char* sRoadString, long* lSymbolType, long* lSymbolRotation, long* lLevel, double* lat, double* lon);

extern "C" long UrbanArea(long* lDataSet, char* sName);
extern "C" long UrbanAreaPoint(long* lDataSet, long* index, double* lat, double* lon);

extern "C" long Park(long* lDataset, char* newName, long* lType);
extern "C" long ParkPoint(long* lDataset, long* index, long* lType, double* lat, double* lon);

extern "C" long CityName(long* lDataset, char* newName, long* lType, double* lat, double* lon);
extern "C" long WaterName(long* lDataset, char* newName, long* lType, double* lat, double* lon);

extern "C" long Stream(long* lDataSet, long* lType, char* sName);
extern "C" long StreamPoint(long* lDataset, long* index, double* lat, double* lon);

extern "C" long Trail(long* lDataSet, long* lType, char* sName);
extern "C" long TrailPoint(long* lDataset, long* index, double* lat, double* lon);

extern "C" long Rail(long* lDataSet);
extern "C" long RailPoint(long* lDataset, long* index, double* lat, double* lon);

extern "C" long Boundary(long* lDataSet, long* lType, char* sName);
extern "C" long BoundaryPoint(long* lDataset, long* index, long* lType, double* lat, double* lon);

extern "C" long POI(long* lDataSet, structPOI* myPOI);
extern "C" long TrailPOI(long* lDataSet, structPOI* myPOI);
extern "C" long Wreck(long* lDataSet, char* sName, long* lLevel, long* lType, double* lat, double* lon);
extern "C" long Obstruction(long* lDataSet, char* sName, long* lLevel, long* lType, double* lat, double* lon);
extern "C" long Navaid(long* lDataSet, char* sName, long* lLevel, long* lType, long* lIndex, double* lat, double* lon);

unsigned long ForestGetNumberPoints(long index);
unsigned long GetNumberForests();
unsigned long GetNumberLakes();
unsigned long LakeGetNumberPoints(long index);
extern "C" long BoundsFull(double* lat1, double* lon1, double* lat2, double* lon2);
extern "C" long SetGrid(long* lGridNumber);
extern "C" long SetGridArray(long* lGridX, long* lGridY);

#endif
