//
// GPSMapEdit
// (c) Konstantin Galichsky (kg@geopainting.com), 2009
//
// Generic edit-action to apply some function to the map.
//

# include "StdAfx.h"
# include "MapAction.h"
# include "UndoRedo.h"

class CMapAction : public CEditAction {
  public:
	CMapAction (bool (* _pf) (bool), const string_t & _strName, bool _bSilent) :
		m_pf (_pf),
		m_strName (_strName),
		m_bSilent (_bSilent)
	{}

	virtual void GetName (string_t & _str) const {_str.append (m_strName);}
	virtual cu_t CanUndo () const {return cuBackup;}
	virtual bool Do ();
	virtual void Undo () {}
	virtual void Redo () {}

  private:
	bool (* const m_pf) (bool);
	const string_t m_strName;
	const bool m_bSilent;
};

bool CMapAction::Do () {
	return m_pf (m_bSilent);
}

void PerformMapAction (bool (* _pf) (bool), const string_t & _strName, bool _bSilent) {
	PerformEditAction (new CMapAction (_pf, _strName, _bSilent));
}
