# ifndef __MapView_H_
# define __MapView_H_

extern HWND g_hMapWnd;
extern HWND g_hMapTipWnd;

extern bool g_bAutoReturnFocusToParent;

extern HDC g_hMemDC;

bool InitMapWindow ();
void DestroyMapWindow ();
void UpdateMapWindowPos ();

bool InitTooltip ();

	// Deep refresh: includes memory buffer update.
void Refresh ();
void DelayedRefresh (DWORD _dwTimeout);
void PostRefresh ();
	// Fast refresh using memory buffer.
void Redraw (const RECT * _pRect = NULL);

void ScrollMap (WORD _wActionH, long _nTrackH, WORD _wActionV, long _nTrackV);
void ShiftMap (long _lShiftX, long _lShiftY);

const int c_iMargin = 50;

extern bool g_bShowRuler;
extern bool g_bShowLabels;
extern bool g_bShowGridLines;
extern bool g_bTransparentPolygons;
extern bool g_bShowAttachments;
extern bool g_bShowMap;
extern bool g_bShowCoverageArea;
extern bool g_bShowBookmarksAndNotes;
extern bool g_bShowRGNodes;
extern bool g_bShowRoadClasses;
extern bool g_bHighlightAddresses;
extern bool g_bShowNumbers;
extern bool g_bShowHLevel;
extern bool g_bShowPolygonContours;
extern bool g_bShowGoogleMaps;

extern bool g_bTTShowType;
extern bool g_bTTShowComment;
extern bool g_bTTShowStreetAndNumber;
extern bool g_bTTShowCity;
extern bool g_bTTShowZipCode;
extern bool g_bTTShowPhone;
extern bool g_bTTShowRouting;
extern bool g_bTTShowDescription;

extern bool g_bTTShowTime;
extern bool g_bTTShowSpeed;
extern bool g_bTTShowHDOP;
extern bool g_bTTShowVDOP;
extern bool g_bTTShowSatellites;
extern bool g_bTTShowFix;

# endif // __MapView_H_