//
// GPSMapEdit
// (c) Konstantin Galichsky (kg@geopainting.com), 2002-2008
// (c) Rafal Fitt (fitt@aplusc.com.pl), 2004
//
// 'Options' dialog.
//

# include "StdAfx.h"
# include "Resource.h"
# include "Options.h"
# include "Settings.h"
# include "MapView.h"
# include "Types.h"
# include "Globals.h"

void ShowOptions (size_t _cFirstPage) {
	// Prepare pages.
	const size_t c_cPages = 7;
	PROPSHEETPAGE pshp [c_cPages];
	::memset (pshp, 0, sizeof (pshp));
	for (size_t cPage = 0; cPage < c_cPages; ++ cPage) {
		pshp [cPage].dwSize    = sizeof (PROPSHEETPAGE);
		pshp [cPage].dwFlags   = PSP_DEFAULT;
		pshp [cPage].hInstance = g_hResInst;
	}

	pshp [0].pszTemplate = MAKEINTRESOURCE (IDD_OPTIONS_EDIT);
	pshp [0].pfnDlgProc  = _OptionsEditProc;

	pshp [1].pszTemplate = MAKEINTRESOURCE (IDD_OPTIONS_VIEW);
	pshp [1].pfnDlgProc  = _OptionsViewProc;

	pshp [2].pszTemplate = MAKEINTRESOURCE (IDD_OPTIONS_GPS_TRACKING);
	pshp [2].pfnDlgProc  = _OptionsGpsTrackingProc;

	pshp [3].pszTemplate = MAKEINTRESOURCE (IDD_OPTIONS_FILE);
	pshp [3].pfnDlgProc  = _OptionsFileProc;

	pshp [4].pszTemplate = MAKEINTRESOURCE (IDD_OPTIONS_UNITS);
	pshp [4].pfnDlgProc  = _OptionsUnitsProc;

	pshp [5].pszTemplate = MAKEINTRESOURCE (IDD_OPTIONS_WEBMAP);
	pshp [5].pfnDlgProc  = _OptionsWebMapProc;

	pshp [6].pszTemplate = MAKEINTRESOURCE (IDD_OPTIONS_COMMON);
	pshp [6].pfnDlgProc  = _OptionsCommonProc;

	// Prepare header.
	PROPSHEETHEADER psh;
	::memset (& psh, 0, sizeof (psh));
	psh.dwSize     = sizeof (psh);
	psh.dwFlags    = PSH_PROPSHEETPAGE;
	psh.hwndParent = g_hWnd;
	psh.hInstance  = g_hResInst;
	psh.nPages     = c_cPages;
	psh.nStartPage = _cFirstPage;
	psh.ppsp       = pshp;
	psh.pszCaption = "Options";

	::PropertySheet (& psh);
}