//
// GPSMapEdit
// (c) Konstantin Galichsky (kg@geopainting.com), 2008-2009
//
// Position parsing helper utility.
//

# include "StdAfx.h"
# include "ParsePosition.h"
# include "ParseHelpers.h"
# include "PtAlgo.h"

bool ParsePosition (point_t & _pt, const char * _strPosition, const char * _pEnd, const char ** _ppEnd) {
	const char * p = _strPosition;

	if (_pEnd == NULL)
		_pEnd = _strPosition + ::strlen (_strPosition);

	if (_ppEnd != NULL)
		* _ppEnd = _pEnd;

	OmitSpaces (& p, _pEnd);
	if (* p == 'E' || * p == 'W' || * p == 'N' || * p == 'S') {
		const bool bEW1 = * p == 'E' || * p == 'W';

		float f1;
		if (! ParseArc (p, _pEnd, & p, f1, false))
			return false;

		OmitSpaces (& p, _pEnd);
		if (* p == ',') {
			++ p;
			OmitSpaces (& p, _pEnd);
		}
		const bool bNS2 = * p == 'N' || * p == 'S';

		float f2;
		if (! ParseArc (p, _pEnd, & p, f2, false))
			return false;

		OmitSpaces (& p, _pEnd);
		if (p != _pEnd && _ppEnd == NULL)
			return false;

		if (bEW1 && bNS2) {
			_pt.x = f1;
			_pt.y = f2;
		} else {
			_pt.x = f2;
			_pt.y = f1;
		}

		if (_ppEnd != NULL)
			* _ppEnd = p;
		return true;
	} else {
		float f1;
		if (! ParseReal (p, _pEnd, & p, f1))
			return false;

		OmitSpaces (& p, _pEnd);
		if (* p == ',') {
			++ p;
			OmitSpaces (& p, _pEnd);
		}

		float f2;
		if (! ParseReal (p, _pEnd, & p, f2))
			return false;

		OmitSpaces (& p, _pEnd);
		if (p != _pEnd && _ppEnd == NULL)
			return false;

		_pt.x = f2;
		_pt.y = f1;
		if (_ppEnd != NULL)
			* _ppEnd = p;
		return true;
	}
}
