# ifndef __Paths_H_
# define __Paths_H_

# include "FVector.h"
# include "PtAlgo.h"

struct CPath_t {
	COLORREF col;
	COLORREF colHS;
	size_t cWidth;
	size_t cVertexSize;

	points_t points;
	rect_t rectBound;

	size_t cHSFrom;
	size_t cHSTo;

	CComVariant vTag;

	bool bHidden;
	bool bShowDirection;
	bool bShowVertices;
	bool bFillArea;
	bool bTransparentArea;

	COLORREF colArea;

	string_t strLabel;
	COLORREF colLabel;

	CComBSTR bstrInfotip;
	CComBSTR bstrInfotipsForPoints;
	fvector<size_t> InfotipsForPoints;

	CPath_t () :
		col (0), colHS (0), colArea (0), colLabel (0),
		cHSFrom (0), cHSTo (0),
		cWidth (1), cVertexSize (0),
		bHidden (false), bShowDirection (false), bShowVertices (false),
		bFillArea (false), bTransparentArea (false)
	{}
};

typedef std::list<CPath_t> Paths_t;
extern Paths_t g_Paths;

void DrawPaths (HDC _hDC, const rect_t & _rectVisible);
void DeletePath (CPath_t & _path);

void GetPathInfotip (int _x, int _y, string_t & _strInfotip);
void GetPathAreaInfotip (int _x, int _y, string_t & _strInfotip);

void SetPathAreaLabelFont (const char * _strFont, int _nSize, bool _bBold, bool _bItalics);
void DestroyPaths ();

# endif // __Paths_H_