//
// GPSMapEdit
// (c) Konstantin Galichsky (kg@geopainting.com), 2004-2009
//
// The RUSSA-specific type set.
//

# include "StdAfx.h"
# include "Resource.h"
# include "RussaTypes.h"
# include "NavitelTypes.h"
# include "GarminTypes.h"
# include "GarminRound.h"
# include "Map.h"
# include "TypesDraw.h"
# include "TypesPOIDraw.h"
# include "Globals.h"

static
void _InitRussaTypes () {
	CTypeSet::types_t types_impl;
	InitNavitelTypes (types_impl);
	g_tsRussa.SetTypes (types_impl);

	g_tsRussa.strID            = "Russa";
	g_tsRussa.strDisplayName   = "RUSSA";

	g_tsRussa.pfGetLatGrid     = GarminLatGrid;
	g_tsRussa.pfRoundPoint     = GarminRoundPoint;
	g_tsRussa.pfRoundPoints    = GarminRoundPoints;
	g_tsRussa.pfRoundRect      = GarminRoundRect;

	g_tsRussa.pfIsCity         = Garmin_IsCity;
	g_tsRussa.pfIsHeight       = Garmin_IsHeight;
	g_tsRussa.pfIsFeature      = Garmin_IsFeature;
	g_tsRussa.pfIsRoad         = Navitel_IsRoad;
	g_tsRussa.pfIsUnpavedRoad  = Navitel_IsUnpavedRoad;
	g_tsRussa.pfIsRoundabout   = Garmin_IsRoundabout;
	g_tsRussa.pfIsHwExit       = RgnPredicateFalse;
	g_tsRussa.pfIsBackground   = Garmin_IsBackground;
	g_tsRussa.pfIsOneWayRoad   = Navitel_IsOneWayRoad;
	g_tsRussa.pfHasAddress     = RgnPredicateTrue;
	g_tsRussa.pfHasCityAndZip  = RgnPredicateTrue;
	g_tsRussa.pfHasPhone       = RgnPredicateFalse;
	g_tsRussa.pfHasContact     = RgnPredicateFalse;
	g_tsRussa.pfHasDescription = RgnPredicateFalse;

	g_tsRussa.dwFeatures       = CTypeSet::tsfHasCopyright | CTypeSet::tsfHasElevationUnits;

	g_tsRussa.cMaxBits         = 26;
}

static
void _DestroyRussaTypes () {}

CTypeSet g_tsRussa (_InitRussaTypes, _DestroyRussaTypes);

/////////////////////////////////////////////////////////////////////

DWORD ConvertTypeSet_Garmin2Russa (RGN_KIND _Kind, DWORD _dwType) {
	return ConvertTypeSet_Garmin2Navitel (_Kind, _dwType);
}

DECLARE_TYPESET_CONVERTOR (ConvertTypeSet_Garmin2Russa, & g_tsGarmin, & g_tsRussa);

DWORD ConvertTypeSet_Russa2Garmin (RGN_KIND _Kind, DWORD _dwType) {
	return ConvertTypeSet_Navitel2Garmin (_Kind, _dwType);
}

DECLARE_TYPESET_CONVERTOR (ConvertTypeSet_Russa2Garmin, & g_tsRussa, & g_tsGarmin);

DWORD ConvertTypeSet_Russa2Navitel (RGN_KIND _Kind, DWORD _dwType) {
	return _dwType;
}

DECLARE_TYPESET_CONVERTOR (ConvertTypeSet_Russa2Navitel, & g_tsRussa, & g_tsNavitel);