# ifndef __Save_H_
# define __Save_H_

bool RequestSave ();
void SaveMap ();
void SaveMapAs ();

class CFileTypeInfo;
bool SaveMap (const CFileTypeInfo * _pSaverInfo, const char * _strFileName, bool _bSilent);

//////////////////////////////////////

# include "FileTypeInfo.h"

class CMapSaver {
  public:
	CMapSaver () : m_bSilent (false) {}

	void SetSilent (bool _bSilent) {m_bSilent = _bSilent;}

	// NOTE: CanSave() is fast check which does not show GUI.
	virtual bool CanSave       (const map_t & _map) {return true;}
	// NOTE: PrepareToSave() may show some GUI.
	virtual bool PrepareToSave (const map_t & _map) {return true;}

	virtual SaveStatus_t Save (HANDLE _hFile, const char * _strFileName, const map_t & _map) = 0;

  protected:
	bool Silent () const {return m_bSilent;}
	void Warning (const char * _strMessage);
	void Warning (const char * _strMessage, int _n1);
	SaveStatus_t Error (const char * _strMessage);
	SaveStatus_t Error (const char * _strMessage, const char * _str1);

  private:
	bool m_bSilent;
};

# define DECLARE_MAP_SAVER_impl(_T,_strClass,_strExt,_strFilter,_dwFlags) \
	CMapSaver * Create_##_T () {return new _T;} \
	CFileTypeInfo Creator_##_T (NULL, & Create_##_T, _strClass, _strExt, _strFilter, _dwFlags);

# define DECLARE_MAP_SAVER(_T,_strClass,_strExt,_strFilter)         DECLARE_MAP_SAVER_impl (_T, _strClass, _strExt, _strFilter, 0)
# define DECLARE_MAP_SAVER2(_T,_strClass,_strExt,_strFilter,_fl)    DECLARE_MAP_SAVER_impl (_T, _strClass, _strExt, _strFilter, _fl)
# define DECLARE_DEFAULT_MAP_SAVER(_T,_strClass,_strExt,_strFilter) DECLARE_MAP_SAVER_impl (_T, _strClass, _strExt, _strFilter, ftiDefault)
# define DECLARE_MAP_EXPORT(_T,_strClass,_strExt,_strFilter)        DECLARE_MAP_SAVER_impl (_T, _strClass, _strExt, _strFilter, ftiImportExport)
# define DECLARE_MAP_EXPORT2(_T,_strClass,_strExt,_strFilter,_fl)   DECLARE_MAP_SAVER_impl (_T, _strClass, _strExt, _strFilter, ftiImportExport | (_fl))

# define DECLARE_WPTRK_EXPORT(_T,_strClass,_strExt,_strFilter)      DECLARE_MAP_SAVER_impl (_T, _strClass, _strExt, _strFilter, ftiImportExport | ftiWTR)
# define DECLARE_BM_EXPORT(_T,_strClass,_strExt,_strFilter)         DECLARE_MAP_SAVER_impl (_T, _strClass, _strExt, _strFilter, ftiImportExport | ftiBookmarks)

//////////////////////////////////////

struct map_t;
bool CheckVectorData_Silent (const map_t & _map);
bool CheckVectorData        (const map_t & _map);

bool CheckBookmarks_Silent  (const map_t & _map);
bool CheckBookmarks         (const map_t & _map);

# endif // __Save_H_