//
// GPSMapEdit
// (c) Konstantin Galichsky (kg@geopainting.com), 2008
//
// Save thunk dialog.
//

# include "StdAfx.h"
# include "Resource.h"
# include "SaveThunk.h"
# include "FileTypeInfo.h"
# include "Dialog.h"
# include "Settings.h"
# include "Globals.h"

bool SaveThunkIsEnabled () {
	return GetSetting ("DontShowSaveThunk", (DWORD) 0) == 0;
}

////////////////////////////////////////////////

class CSaveThunk : public CDialog {
  public:
    CSaveThunk (const CFileTypeInfo * _pFTI, const char * _strFileName) :
		CDialog (IDD_SAVE_THUNK),
		m_pFTI (_pFTI),
		m_strFileName (_strFileName)
	{}

	// Override.
	virtual bool OnInit (HWND _hwndFocus) {
		::SendDlgItemMessage (m_hWnd, IDC_ICON1, STM_SETICON, (WPARAM) ::LoadIcon (NULL, IDI_INFORMATION), 0);

		// Message body.
		char strMessage [256];
		GetDlgItemText  (IDC_MESSAGE, strMessage, ARRAY_SIZE (strMessage));
		SetDlgItemTextF (IDC_MESSAGE, strMessage, m_pFTI->m_vecExts.size () >= 1 ? m_pFTI->m_vecExts [0].c_str () : "", m_pFTI->m_strFilter.c_str ());

		// 'Export'.
		char strExport [256];
		GetDlgItemText  (IDC_EXPORT, strExport, ARRAY_SIZE (strExport));
		SetDlgItemTextF (IDC_EXPORT, strExport, m_pFTI->m_strFilter.c_str ());

		return true;	
	}
	virtual void OnCommand (WORD _wCmd, WORD _wNotifyCode, HWND _hwndCtl) {
		switch (_wCmd) {
			case IDOK:
			case IDCANCEL:
				if (IsDlgButtonChecked (IDC_DONT_SHOW))
					SaveSetting ("DontShowSaveThunk", (DWORD) 1);
				EndDialog (0);
				break;

			case IDC_EXPORT:
				EndDialog (0);
				m_pFTI->ExportFile (m_strFileName);
				break;
		}
	}

  public:
	const CFileTypeInfo * const m_pFTI;
	const char * const m_strFileName;
};

void ShowSaveThunk (const CFileTypeInfo * _pFTI, const char * _strFileName) {
	CSaveThunk st (_pFTI, _strFileName);
	st.ShowModal (g_hWnd);
}
