//
// GPSMapEdit
// (c) Konstantin Galichsky (kg@geopainting.com), 2009
//
// Generic edit-action to apply number change.
//

# include "StdAfx.h"
# include "MapAction.h"
# include "UndoRedo.h"

class CSetNumberAction : public CEditAction {
  public:
	CSetNumberAction (DWORD & _dw, DWORD _dwNew) :
		m_dw (_dw),
		m_dwOld (_dw),
		m_dwNew (_dwNew)
	{}

	virtual void GetName (string_t & _str) const {_str.append ("<inner>");}
	virtual cu_t CanUndo () const {return cuYes;}
	virtual bool Do ();
	virtual void Undo ();
	virtual void Redo ();

  private:
	DWORD & m_dw;
	const DWORD m_dwOld;
	const DWORD m_dwNew;
};

bool CSetNumberAction::Do () {
	m_dw = m_dwNew;
	return true;
}

void CSetNumberAction::Undo () {
	m_dw = m_dwOld;
}

void CSetNumberAction::Redo () {
	m_dw = m_dwNew;
}

void SetNumber (DWORD & _dw, DWORD _dwNew) {
	PerformEditAction (new CSetNumberAction (_dw, _dwNew));
}