# ifndef __SetRGNodeRestriction_H_
# define __SetRGNodeRestriction_H_

# include "UndoRedo.h"

struct rgrestriction_t;

class CAddRGNodeRestrictionAction : public CEditAction {
  public:
	CAddRGNodeRestrictionAction (const rgrestriction_t & _restriction) :
		m_pRestriction (NULL),
		m_restriction (_restriction),
		m_bHadRestrictions (_restriction.pNode != NULL ? _restriction.pNode->bHasRestrictions : false)
	{}

	virtual void GetName (string_t & _str) const;
	virtual cu_t CanUndo () const {return cuYes;}
	virtual bool Do ();
	virtual void Undo ();
	virtual void Redo ();

  private:
	rgrestriction_t *     m_pRestriction;
	const rgrestriction_t m_restriction;
	const bool            m_bHadRestrictions;
};

void AddRGNodeRestriction (const rgrestriction_t & _restriction);
void RemoveRGNodeRestriction (rgrestriction_t & _restriction);
void SetRGNodeRestriction (rgrestriction_t & _restriction, const rgrestriction_t & _restrictionNew);

# endif // __SetRGNodeRestriction_H_