//
// GPSMapEdit
// (c) Konstantin Galichsky (kg@infratel.com), 2002-2004
//
// ESRI shapefile export wizard.
// NOTE: the code is incomplete.
//

# include "StdAfx.h"
# include "Map.h"
# include "Save.h"
# include "Log.h"
# include "Status.h"
# include "ShpFile.h"
# include "DbfFile.h"
# include "FileWriter.h"
# include "fast_floor.h"
# include "ParseHelpers.h"
# include "Globals.h"
/*
typedef DWORD (* pfWriteShape_t) (const rgn_t & _rgn, rect_t & _rectBound, CFileWriter & _fwShp, size_t _cOrdinal);

static
DWORD WritePoint (const rgn_t & _rgn, rect_t & _rectBound, CFileWriter & _fwShp, size_t _cOrdinal) {
	const rgn_origins_t & origins = _rgn.origins;

	point_t pt;
	bool bPtDefined = false;
	for (size_t cOrigin = 0; cOrigin < origins.size (); ++ cOrigin) {
		const rgn_origin_t & origin = origins [cOrigin];

		if (origin.cLevel == 0) {
			pt = origin.point;
			bPtDefined = true;
			break;
		}
	}
	if (! bPtDefined) {
		CShpNullData null;
		null.dwOrdinal = Big2LowEndian (_cOrdinal);
		null.dwLen     = Big2LowEndian (1);

		_fwShp.WriteBin (& null, sizeof (null));

		return null.dwLen;
	}

	const size_t cRecordLen = sizeof (CShpPoint);

	CShpPoint point;
	point.dwOrdinal = Big2LowEndian (_cOrdinal);
	point.dwLen     = Big2LowEndian ((cRecordLen - 8)/sizeof (WORD));

	point.dwType = shpPoint;

	point.point.dX = pt.x;
	point.point.dY = pt.y;

	_fwShp.WriteBin (& point, sizeof (point));

	_rectBound.Extend (pt);

	return point.dwLen;
}

static
DWORD WritePolyline (const rgn_t & _rgn, rect_t & _rectBound, CFileWriter & _fwShp, size_t _cOrdinal) {
	rect_t rgn_rectBound;

	const rgn_elements_t & elements = _rgn.elements;
	const size_t cParts = elements.size ();

	// Count points.
	size_t cPoints = 0;
	size_t cElement;
	for (cElement = 0; cElement < elements.size (); ++ cElement) {
		const rgn_element_t & element = elements [cElement];

		cPoints += element.points.size ();

		for (size_t cPoint = 0; cPoint < element.points.size (); ++ cPoint)
			rgn_rectBound.Extend (element.points [cPoint]);
	}

	const size_t cRecordLen = sizeof (CShpPolyline) - sizeof (DWORD) + cParts*sizeof (DWORD) + cPoints*sizeof (CShpPointData);

	//
	// Prepare record header.
	//

	CShpPolyline polyline;
	polyline.dwOrdinal = Big2LowEndian (_cOrdinal);
	polyline.dwLen     = Big2LowEndian ((cRecordLen - 8)/sizeof (WORD));

	polyline.dwType = shpPolyline;

	polyline.box.dX0 = rgn_rectBound.x0;
	polyline.box.dX1 = rgn_rectBound.x1;
	polyline.box.dY0 = rgn_rectBound.y0;
	polyline.box.dY1 = rgn_rectBound.y1;

	polyline.dwNumParts  = cParts;
	polyline.dwNumPoints = cPoints;

	//
	// Prepare parts & points.
	//

	DWORD * const pParts = reinterpret_cast<DWORD *> (::alloca (sizeof (DWORD)*cParts));
	CShpPointData * const pPoints = reinterpret_cast<CShpPointData *> (::alloca (sizeof (CShpPointData)*cPoints));
	size_t cPointIndex = 0;
	for (cElement = 0; cElement < elements.size (); ++ cElement) {
		pParts [cElement] = cPointIndex;

		const rgn_element_t & element = elements [cElement];
		for (size_t cPoint = 0; cPoint < element.points.size (); ++ cPoint) {
			pPoints [cPointIndex].dX = element.points [cPoint].x;
			pPoints [cPointIndex].dY = element.points [cPoint].y;

			++ cPointIndex;
		}
	}

	// Write header.
	_fwShp.WriteBin (& polyline, sizeof (polyline) - sizeof (polyline.dwaParts));
	// Write parts.
	_fwShp.WriteBin (pParts, sizeof (DWORD)*cParts);
	// Write points.
	_fwShp.WriteBin (pPoints, sizeof (CShpPointData)*cPoints);

	_rectBound.Extend (rgn_rectBound);

	return polyline.dwLen;
}

static
DWORD WritePolygon (const rgn_t & _rgn, rect_t & _rectBound, CFileWriter & _fwShp, size_t _cOrdinal) {
	rect_t rgn_rectBound;

	// NOTE: make copy of elements for modifications.
	rgn_elements_t elements = _rgn.elements;
	const size_t cParts = elements.size ();

	// Count points.
	size_t cPoints = 0;
	size_t cElement;
	for (cElement = 0; cElement < elements.size (); ++ cElement) {
		rgn_element_t & element = elements [cElement];
		points_t & points = element.points;

		if (points.empty ())
			continue;

		// Make sure that first and last are equal.
		if (! (points.front () == points.back ()))
			points.push_back (points.front ());

		cPoints += points.size ();

		for (size_t cPoint = 0; cPoint < points.size (); ++ cPoint)
			rgn_rectBound.Extend (points [cPoint]);

		// Provide proper orientation.
		if (
			(element.bHole == true  && IsRightOriented (points) == true) ||
			(element.bHole == false && IsRightOriented (points) == false)
		)
			std::reverse (points.begin (), points.end ());
	}

	const size_t cRecordLen = sizeof (CShpPolygon) - sizeof (DWORD) + cParts*sizeof (DWORD) + cPoints*sizeof (CShpPointData);

	//
	// Prepare record header.
	//

	CShpPolygon polygon;
	polygon.dwOrdinal = Big2LowEndian (_cOrdinal);
	polygon.dwLen     = Big2LowEndian ((cRecordLen - 8)/sizeof (WORD));

	polygon.dwType = shpPolygon;

	polygon.box.dX0 = rgn_rectBound.x0;
	polygon.box.dX1 = rgn_rectBound.x1;
	polygon.box.dY0 = rgn_rectBound.y0;
	polygon.box.dY1 = rgn_rectBound.y1;

	polygon.dwNumParts  = cParts;
	polygon.dwNumPoints = cPoints;

	//
	// Prepare parts & points.
	//

	DWORD * const pParts = reinterpret_cast<DWORD *> (::alloca (sizeof (DWORD)*cParts));
	CShpPointData * const pPoints = reinterpret_cast<CShpPointData *> (::alloca (sizeof (CShpPointData)*cPoints));
	size_t cPointIndex = 0;
	for (cElement = 0; cElement < elements.size (); ++ cElement) {
		pParts [cElement] = cPointIndex;

		const rgn_element_t & element = elements [cElement];
		for (size_t cPoint = 0; cPoint < element.points.size (); ++ cPoint) {
			pPoints [cPointIndex].dX = element.points [cPoint].x;
			pPoints [cPointIndex].dY = element.points [cPoint].y;

			++ cPointIndex;
		}
	}

	// Write header.
	_fwShp.WriteBin (& polygon, sizeof (polygon) - sizeof (polygon.dwaParts));
	// Write parts.
	_fwShp.WriteBin (pParts, sizeof (DWORD)*cParts);
	// Write points.
	_fwShp.WriteBin (pPoints, sizeof (CShpPointData)*cPoints);

	_rectBound.Extend (rgn_rectBound);

	return polygon.dwLen;
}

static
void CShpSavePolylines (
	const char * _strShpName,
	const char * _strShxName,
	const char * _strDbfName,
	const char * _strBaseDbfName,
	const std::vector<size_t> & _vecDbfIndex,
	map_t * _pMap,
	RGN_KIND       _Kind,
	shp_type_t     _shp_type,
	pfWriteShape_t _pfWriteShape
) {
	//
	const CHandle hBaseDbfFile = ::CreateFile (_strBaseDbfName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hBaseDbfFile == NULL || hBaseDbfFile == INVALID_HANDLE_VALUE) {
		ErrorMsgBox ("Can't open file\n%s.", _strBaseDbfName);
		return;
	}

	const size_t cBaseDbfSize = ::GetFileSize (hBaseDbfFile, NULL);
	char * const pBaseDbfData = new char [cBaseDbfSize];
	CByteArrayHolder bah (reinterpret_cast<BYTE *> (pBaseDbfData));

	DWORD dwRead = 0;
	::ReadFile (hBaseDbfFile, pBaseDbfData, cBaseDbfSize, & dwRead, NULL);
	if (dwRead < cBaseDbfSize) {
		ErrorMsgBox ("Failed to read DBF file: '%s'.", _strBaseDbfName);
		return;
	}

	CDbfHdr * const pDbfHdr = reinterpret_cast<CDbfHdr *> (pBaseDbfData);
	const char * pDbfRecords = pBaseDbfData + pDbfHdr->wHdrSize;

	////////////////////////////////////////

	const CHandle hShpFile = ::CreateFile (_strShpName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if (hShpFile == NULL || hShpFile == INVALID_HANDLE_VALUE) {
		ErrorMsgBox ("Can't open file\n%s.", _strShpName);
		return;
	}
	
	CFileWriter fwShp (hShpFile);

	//

	const CHandle hShxFile = ::CreateFile (_strShxName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if (hShxFile == NULL || hShxFile == INVALID_HANDLE_VALUE) {
		ErrorMsgBox ("Can't open file\n%s.", _strShxName);
		return;
	}

	//

	CFileWriter fwShx (hShxFile);

	const CHandle hDbfFile = ::CreateFile (_strDbfName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if (hDbfFile == NULL || hDbfFile == INVALID_HANDLE_VALUE) {
		ErrorMsgBox ("Can't open file\n%s.", _strShxName);
		return;
	}

	CFileWriter fwDbf (hDbfFile);

	//
	// Save DBF header (incomplete).
	//

	fwDbf.WriteBin (pDbfHdr, pDbfHdr->wHdrSize);

	//
	// Save SHP/SHX header (incomplete).
	//

	CShpHdr hdr;
	hdr.dwSignature = c_dwShpSignature;

	::memset (& hdr.dwaReserved1, 0, sizeof (hdr.dwaReserved1));

	hdr.dwVersion = 1000;
	hdr.dwType = _shp_type;

	hdr.dZ0 = 1e-38;
	hdr.dZ1 = 1e-38;
	hdr.dM0 = 1e-38;
	hdr.dM1 = 1e-38;

	fwShp.WriteBin (& hdr, sizeof (hdr));
	fwShx.WriteBin (& hdr, sizeof (hdr));

	//
	// Prepare to write records.
	//

	size_t cOrdinal = 1;

	rect_t rectBound;
	size_t cFileLen = sizeof (hdr);

	const layer_t & layer = _pMap->layers [_Kind];
	const rgns_t & rgns = layer.rgns;

	for (rgns_t::const_iterator iRgn = rgns.begin (); iRgn != rgns.end (); ++ iRgn) {
		const rgn_t & rgn = * iRgn;
		if (rgn.IsDeleted ())
			continue;

		//
		// Write record to SHP.
		//

		const size_t cOffset = fwShp.GetPos ();
		const DWORD dwLen = _pfWriteShape (rgn, rectBound, fwShp, cOrdinal);

		//
		// Write record to SHX.
		//

		CShxRecord index;
		index.dwOffset = Big2LowEndian (cOffset/sizeof (WORD));
		index.dwLen = dwLen;

		fwShx.WriteBin (& index, sizeof (index));

		++ cOrdinal;

		//
		// Copy record to DBF.
		//

		const size_t cRecordIndex = _vecDbfIndex [rgn.cOrdinal];
		fwDbf.WriteBin (pDbfRecords + pDbfHdr->wRecordSize*cRecordIndex, pDbfHdr->wRecordSize);

		//


	}

	//
	// Rewrite SHP header.
	//

	hdr.dwFileLen = Big2LowEndian ((fwShp.GetPos ())/sizeof (WORD));

	hdr.box.dX0 = rectBound.x0;
	hdr.box.dX1 = rectBound.x1;
	hdr.box.dY0 = rectBound.y0;
	hdr.box.dY1 = rectBound.y1;

	fwShp.SetPos (0);
	fwShp.WriteBin (& hdr, sizeof (hdr));

	fwShp.FlushBuffer ();

	//
	// Rewrite SHX header.
	//

	hdr.dwFileLen = Big2LowEndian (fwShx.GetPos ()/sizeof (WORD));

	fwShx.SetPos (0);
	fwShx.WriteBin (& hdr, sizeof (hdr));

	fwShx.FlushBuffer ();

	//
	// Rewrite DBF header.
	//

	pDbfHdr->dwNumRecords = cOrdinal - 1;
	fwDbf.SetPos (0);
	fwDbf.WriteBin (pDbfHdr, pDbfHdr->wHdrSize);

	fwDbf.FlushBuffer ();
}

void CShpSave (const char * _strFileName, map_t * _pMap, const std::vector<size_t> & _vecDbfIndex) {
	string_t strBaseName;
	const char * const pExt = ::strrchr (_strFileName, '.');
	if (pExt == NULL)
		strBaseName.assign (_strFileName);
	else
		strBaseName.assign (_strFileName, pExt);

	const string_t strBaseDbf = strBaseName + ".dbf";

	CShpSavePolylines ((strBaseName + "_p.shp").c_str (), (strBaseName + "_p.shx").c_str (), (strBaseName + "_p.dbf").c_str (), strBaseDbf.c_str (), _vecDbfIndex, _pMap, rkPoint,      shpPoint,    WritePoint);
	CShpSavePolylines ((strBaseName + "_l.shp").c_str (), (strBaseName + "_l.shx").c_str (), (strBaseName + "_l.dbf").c_str (), strBaseDbf.c_str (), _vecDbfIndex, _pMap, rkPolyline, shpPolyline, WritePolyline);
	CShpSavePolylines ((strBaseName + "_a.shp").c_str (), (strBaseName + "_a.shx").c_str (), (strBaseName + "_a.dbf").c_str (), strBaseDbf.c_str (), _vecDbfIndex, _pMap, rkPolygon,  shpPolygon,  WritePolygon);
}
*/