# ifndef __TVRBase_H_
# define __TVRBase_H_

# include "CPtr.h"
# include "WTR.h"

class tv_bookmarks_t;

class CTrackVideoRendererBase : public CCounted<CTrackVideoRendererBase> {
  public:
	CTrackVideoRendererBase (const char * _strTrackFileName);
	virtual ~CTrackVideoRendererBase ();

	virtual size_t GetChannels () const = 0;
	virtual size_t GetWidth  (size_t _cChannel) const = 0;
	virtual size_t GetHeight (size_t _cChannel) const = 0;
	virtual size_t GetFPS () const = 0;

	virtual void GetVehicleID (string_t & _strId) const {}
	virtual bool GetVehicleInfo (point_t & _pt, trackpoint_info_t & _tpi) const = 0;
	virtual bool IsAtStart () const = 0;
	virtual bool IsAtEnd   () const = 0;
	virtual double GetProgress () const = 0;
	virtual void SetProgress (double _fPart) = 0;
	virtual DWORD GetProgressPrec () const = 0;
	virtual void SetProgressPrec (DWORD _fProgressPrec) = 0;
	virtual void GoForward  (size_t _cTimes = 1, bool _bFast = false) = 0;
	virtual void GoBackward (size_t _cTimes = 1) = 0;
	virtual void GoFrame (size_t _cTrackPointVideoData0, size_t _cTrackPointVideoData1) = 0;

	virtual void SetSpeed (float _fSpeed) = 0;
	virtual double GetSoundLevel () = 0;
	virtual void Mute (bool _bMute) = 0;

	virtual bool Render (HDC _hDC, int _nLeft, int _nTop, int _nWidth, int _nHeight, size_t _cChannel) const = 0;
	virtual bool CaptureDIBitmap (size_t _cChannel, void * _pBits, const BITMAPINFO * _pBMI) const = 0;

	tv_bookmarks_t * GetBookmarks () const {return m_pBookmarks;}

  private:
	tv_bookmarks_t * const m_pBookmarks;
};

# endif // __TVRBase_H_