//
// GPSMapEdit
// (c) Konstantin Galichsky (kg@geopainting.com), 2009
//
// Helpers for time periods.
//

# include "StdAfx.h"
# include "TimePeriod.h"
# include "Globals.h"

void DisplayTimePeriods (const time_periods_t & _TimePeriods, string_t & _str, bool _bShort) {
	if (_TimePeriods.empty ())
		return;

	const size_t cTimePeriods = _TimePeriods.size ();
	for (size_t c = 0; c < cTimePeriods; ++ c) {
		if (c >= 1) {
			if (_bShort) {
				_str.append (", ...");
				break;
			} else
				_str.append (", ");
		}

		const time_period_t & TimePeriod = _TimePeriods [c];

		if (TimePeriod.btDaysOfWeek != 0x7F) {
			if (TimePeriod.btDaysOfWeek == 0x3E)
				_str.append ("WD ");
			else
				_str.append ("* ");
		}

		SYSTEMTIME stFrom;
		::memset (& stFrom, 0, sizeof (stFrom));
		stFrom.wHour   = TimePeriod.btFromHour;
		stFrom.wMinute = TimePeriod.btFromMin;
		char strTimeFrom [32];
		::GetTimeFormat (LOCALE_USER_DEFAULT, TIME_NOSECONDS, & stFrom, NULL, strTimeFrom, ARRAY_SIZE (strTimeFrom));

		SYSTEMTIME stTo;
		::memset (& stTo, 0, sizeof (stTo));
		stTo.wHour   = TimePeriod.btToHour;
		stTo.wMinute = TimePeriod.btToMin;
		char strTimeTo [32];
		::GetTimeFormat (LOCALE_USER_DEFAULT, TIME_NOSECONDS, & stTo, NULL, strTimeTo, ARRAY_SIZE (strTimeTo));

		_str.append (strTimeFrom);
		_str.append ("-");
		_str.append (strTimeTo);
	}
}