# ifndef __TimePeriod_H_
# define __TimePeriod_H_

struct time_period_t {
	// 0x1 for Sunday, 0x2 for Monday, 0x4 for Tuesday etc
	BYTE btDaysOfWeek;

	BYTE btFromHour;
	BYTE btFromMin;

	BYTE btToHour;
	BYTE btToMin;

	time_period_t () : btDaysOfWeek (0x7f), btFromHour (0), btFromMin (0), btToHour (24), btToMin (0) {}

	bool IsAllTheTime () const {
		return btDaysOfWeek == 0x7f && btFromHour == 0 && btFromMin == 0 && btToHour == 24 && btToMin == 0;
	}

	bool operator == (const time_period_t & _other) const {
		return
			btDaysOfWeek == _other.btDaysOfWeek &&
			btFromHour   == _other.btFromHour   &&
			btFromMin    == _other.btFromMin    &&
			btToHour     == _other.btToHour     &&
			btToMin      == _other.btToMin;
	}
};

# include "fvector.h"

typedef fvector<time_period_t> time_periods_t;

void DisplayTimePeriods (const time_periods_t & _TimePeriods, string_t & _str, bool _bShort);

# endif // __TimePeriod_H_