# ifndef __TrackVideoBookmark_H_
# define __TrackVideoBookmark_H_

struct rgn_t;

class tv_bookmarks_t {
  public:
	tv_bookmarks_t () {Clear ();}

	void Init (const char * _strTrackFileName);
	void Update ();

	bool Empty () const {return m_bookmarks.empty ();}
	void Clear (bool _bResetPos = true);

	void SetPositionPrec (DWORD _dwPositionInFile);

	size_t GetBookmarks () const {return m_bookmarks.size ();}

	void AddHere (rgn_t & _rgn);
	void DeleteHere (size_t _cOrdinal);

	size_t GetBookmarksHere () const;
	rgn_t * GetBookmarkHere (size_t _cOrdinal) const;

	DWORD FindPrevPosition () const;
	DWORD FindNextPosition () const;

	bool HasPrevPosition () const;
	bool HasNextPosition () const;

  private:
	string_t m_strTrackFileName;
	DWORD m_dwPositionInFile;

	typedef std::multimap<DWORD, rgn_t *> offset2bookmarks_t;
	offset2bookmarks_t m_bookmarks;

	offset2bookmarks_t::iterator m_iLowerBound;
	offset2bookmarks_t::iterator m_iUpperBound;
	size_t m_cBookmarks;
	void _UpdateHere ();
};

# endif // __TrackVideoBookmark_H_