//
// GPSMapEdit
// (c) Konstantin Galichsky (kg@geopainting.com), 2008-2009
// (c) Eugene Prosso (eprosso@navitel.su), 2008
//
// Verify polygons overlapping and self-intersection.
//

# include "StdAfx.h"
# include "Map.h"
# include "PolygonIntersections.h"

void VerifyPolygonOverlapping (bool _bCheckSelfIntersections, bool _bCheckOverlappingPolygons) {
	CCritSec::CLock lock (g_cs);
	CPolygonIntersections intersectionsProcessor;
	intersections_t contourIntersections, internalOverlappings;

	const size_t cLevels = g_map.Levels.empty () ? 1 : g_map.Levels.size ();
	for (size_t cLevel = 0; cLevel < cLevels; ++ cLevel)
		intersectionsProcessor.VerifyPolygonOverlapping (
			g_map.layers [rkPolygon].rgns, cLevel, 
			_bCheckSelfIntersections, _bCheckOverlappingPolygons,
			contourIntersections, internalOverlappings
		);

	intersectionsProcessor.ReportIntersections (contourIntersections);
	intersectionsProcessor.ReportIntersections (internalOverlappings);
}