# ifndef __ViewPlugins_H_
# define __ViewPlugins_H_

void InitViewPlugins ();
void DestroyViewPlugins ();

bool ViewPlugins_CanCustomize ();
void ViewPlugins_Customize (HWND _hWnd);

bool ViewPlugins_HasToDrawBefore ();
bool ViewPlugins_HasToDrawAfter  ();

struct rect_t;
void ViewPlugins_Draw (HDC _hDC, const rect_t & _rectVisible, bool _bBeforeMap);

void ViewPlugins_OnSwitch (UINT _uiCmd, bool _bMenu);
struct IViewPlugin;
bool ViewPlugins_GetSwitch    (IViewPlugin * _pPlugin, long _lSwitchIdx);
void ViewPlugins_SetSwitch    (IViewPlugin * _pPlugin, long _lSwitchIdx, bool _bCheck);
void ViewPlugins_EnableSwitch (IViewPlugin * _pPlugin, long _lSwitchIdx, bool _bEnable);

bool ViewPlugins_OnLeftDown   (int _x, int _y, bool _bBeforeMap);
bool ViewPlugins_OnLeftUp     (int _x, int _y, bool _bBeforeMap);
bool ViewPlugins_OnLeftDblClk (int _x, int _y, bool _bBeforeMap);
bool ViewPlugins_OnRightDown  (int _x, int _y, bool _bBeforeMap);
bool ViewPlugins_OnRightUp    (int _x, int _y, bool _bBeforeMap);
void ViewPlugins_OnMove       (int _x, int _y);
void ViewPlugins_OnHover      (int _x, int _y, bool _bBeforeMap, string_t & _strHint);

# endif // __ViewPlugins_H_